---
title: Create Custom Hostname
---

[Skip to content](#_top)

[API Reference](https://developers.cloudflare.com/api/go)

[Custom Hostnames](https://developers.cloudflare.com/api/go/resources/custom_hostnames)

Copy Markdown

Open in **Claude**Open in **ChatGPT**Open in **Cursor**

---

**Copy Markdown****View as Markdown**

# Create Custom Hostname

client.CustomHostnames.New(ctx, params) (\*[CustomHostnameNewResponse](<https://developers.cloudflare.com/api/go/resources/custom_hostnames#(resource)%20custom_hostnames%20%3E%20(model)%20CustomHostnameNewResponse%20%3E%20(schema)>), error)

POST/zones/{zone\_id}/custom\_hostnames

Add a new custom hostname and request that an SSL certificate be issued for it. One of three validation methods—http, txt, email—should be used, with ‘http’ recommended if the CNAME is already in place (or will be soon). Specifying ‘email’ will send an email to the WHOIS contacts on file for the base domain plus hostmaster, postmaster, webmaster, admin, administrator. If http is used and the domain is not already pointing to the Managed CNAME host, the PATCH method must be used once it is (to complete validation). Enable bundling of certificates using the custom\_cert\_bundle field. The bundling process requires the following condition One certificate in the bundle must use an RSA, and the other must use an ECDSA.

##### Security

<details>

<summary>API Token</summary>



The preferred authorization scheme for interacting with the Cloudflare API. <a href="https://developers.cloudflare.com/fundamentals/api/get-started/create-token/">Create a token</a>.

**Example:**<code>Authorization: Bearer Sn3lZJTBX6kkg7OdcBUAxOO963GEIyGQqnFTOFYY</code>

</details>

<details>

<summary>API Email + API Key</summary>



The previous authorization scheme for interacting with the Cloudflare API, used in conjunction with a Global API key.

**Example:**<code>X-Auth-Email: user@example.com</code>

The previous authorization scheme for interacting with the Cloudflare API. When possible, use API tokens instead of Global API keys.

**Example:**<code>X-Auth-Key: 144c9defac04969c7bfad8efaa8ea194</code>

</details>

##### Accepted Permissions (at least one required)

`SSL and Certificates Write`

##### ParametersExpand Collapse

<details>

<summary>

params CustomHostnameNewParams

</summary>

ZoneID param.Field\[string]

Path param: Identifier.

maxLength32

<a href="#(resource)%20custom_hostnames%20%3E%20(method)%20create%20%3E%20(params)%20default%20%3E%20(param)%20zone_id">Link to this property</a>

Hostname param.Field\[string]

Body param: The custom hostname that will point to your hostname via CNAME.

maxLength255

<a href="#(resource)%20custom_hostnames%20%3E%20(method)%20create%20%3E%20(params)%20default%20%3E%20(param)%20hostname">Link to this property</a>

CustomMetadata param.Field\[map\[string, string]]Optional

Body param: Unique key/value metadata for this hostname. These are per-hostname (customer) settings.

<a href="#(resource)%20custom_hostnames%20%3E%20(method)%20create%20%3E%20(params)%20default%20%3E%20(param)%20custom_metadata">Link to this property</a>

CustomOriginServer param.Field\[string]Optional

Body param: a valid hostname that’s been added to your DNS zone as an A, AAAA, or CNAME record.

<a href="#(resource)%20custom_hostnames%20%3E%20(method)%20create%20%3E%20(params)%20default%20%3E%20(param)%20custom_origin_server">Link to this property</a>

CustomOriginSNI param.Field\[string]Optional

Body param: A hostname that will be sent to your custom origin server as SNI for TLS handshake. This can be a valid subdomain of the zone or custom origin server name or the string ‘:request\_host\_header:’ which will cause the host header in the request to be used as SNI. Not configurable with default/fallback origin server.

<a href="#(resource)%20custom_hostnames%20%3E%20(method)%20create%20%3E%20(params)%20default%20%3E%20(param)%20custom_origin_sni">Link to this property</a>

<details>

<summary>

SSL param.Field\[<a href="https://developers.cloudflare.com/api/go/resources/custom_hostnames/methods/create#(resource)%20custom_hostnames%20%3E%20(method)%20create%20%3E%20(params)%20default%20%3E%20(param)%20ssl%20%3E%20(schema)">CustomHostnameNewParamsSSL</a>]Optional

Body param: SSL properties used when creating the custom hostname.

</summary>

<details>

<summary>

BundleMethod <a href="https://developers.cloudflare.com/api/go/resources/custom_hostnames#(resource)%20custom_hostnames%20%3E%20(model)%20bundle_method%20%3E%20(schema)">BundleMethod</a>Optional

A ubiquitous bundle has the highest probability of being verified everywhere, even by clients using outdated or unusual trust stores. An optimal bundle uses the shortest chain and newest intermediates. And the force bundle verifies the chain, but does not otherwise modify it.

</summary>

One of the following:

const BundleMethodUbiquitous <a href="https://developers.cloudflare.com/api/go/resources/custom_hostnames#(resource)%20custom_hostnames%20%3E%20(model)%20bundle_method%20%3E%20(schema)">BundleMethod</a> = "ubiquitous"

<a href="#(resource)%20custom_hostnames%20%3E%20(method)%20create%20%3E%20(params)%20default%20%3E%20(param)%20ssl%20%3E%20(schema)%20%3E%20(property)%20bundle_method%20%2B%20(resource)%20custom_hostnames%20%3E%20(model)%20bundle_method%20%3E%20(schema)%20%3E%20(member)%200">Link to this property</a>

const BundleMethodOptimal <a href="https://developers.cloudflare.com/api/go/resources/custom_hostnames#(resource)%20custom_hostnames%20%3E%20(model)%20bundle_method%20%3E%20(schema)">BundleMethod</a> = "optimal"

<a href="#(resource)%20custom_hostnames%20%3E%20(method)%20create%20%3E%20(params)%20default%20%3E%20(param)%20ssl%20%3E%20(schema)%20%3E%20(property)%20bundle_method%20%2B%20(resource)%20custom_hostnames%20%3E%20(model)%20bundle_method%20%3E%20(schema)%20%3E%20(member)%201">Link to this property</a>

const BundleMethodForce <a href="https://developers.cloudflare.com/api/go/resources/custom_hostnames#(resource)%20custom_hostnames%20%3E%20(model)%20bundle_method%20%3E%20(schema)">BundleMethod</a> = "force"

<a href="#(resource)%20custom_hostnames%20%3E%20(method)%20create%20%3E%20(params)%20default%20%3E%20(param)%20ssl%20%3E%20(schema)%20%3E%20(property)%20bundle_method%20%2B%20(resource)%20custom_hostnames%20%3E%20(model)%20bundle_method%20%3E%20(schema)%20%3E%20(member)%202">Link to this property</a>

</details>

<a href="#(resource)%20custom_hostnames%20%3E%20(method)%20create%20%3E%20(params)%20default%20%3E%20(param)%20ssl%20%3E%20(schema)%20%3E%20(property)%20bundle_method">Link to this property</a>

<details>

<summary>

CertificateAuthority <a href="https://developers.cloudflare.com/api/go/resources/$shared#(resource)%20%24shared%20%3E%20(model)%20certificate_ca%20%3E%20(schema)">CertificateCA</a>Optional

The Certificate Authority that will issue the certificate.

</summary>

One of the following:

const CertificateCADigicert <a href="https://developers.cloudflare.com/api/go/resources/$shared#(resource)%20%24shared%20%3E%20(model)%20certificate_ca%20%3E%20(schema)">CertificateCA</a> = "digicert"

<a href="#(resource)%20custom_hostnames%20%3E%20(method)%20create%20%3E%20(params)%20default%20%3E%20(param)%20ssl%20%3E%20(schema)%20%3E%20(property)%20certificate_authority%20%2B%20(resource)%20%24shared%20%3E%20(model)%20certificate_ca%20%3E%20(schema)%20%3E%20(member)%200">Link to this property</a>

const CertificateCAGoogle <a href="https://developers.cloudflare.com/api/go/resources/$shared#(resource)%20%24shared%20%3E%20(model)%20certificate_ca%20%3E%20(schema)">CertificateCA</a> = "google"

<a href="#(resource)%20custom_hostnames%20%3E%20(method)%20create%20%3E%20(params)%20default%20%3E%20(param)%20ssl%20%3E%20(schema)%20%3E%20(property)%20certificate_authority%20%2B%20(resource)%20%24shared%20%3E%20(model)%20certificate_ca%20%3E%20(schema)%20%3E%20(member)%201">Link to this property</a>

const CertificateCALetsEncrypt <a href="https://developers.cloudflare.com/api/go/resources/$shared#(resource)%20%24shared%20%3E%20(model)%20certificate_ca%20%3E%20(schema)">CertificateCA</a> = "lets\_encrypt"

<a href="#(resource)%20custom_hostnames%20%3E%20(method)%20create%20%3E%20(params)%20default%20%3E%20(param)%20ssl%20%3E%20(schema)%20%3E%20(property)%20certificate_authority%20%2B%20(resource)%20%24shared%20%3E%20(model)%20certificate_ca%20%3E%20(schema)%20%3E%20(member)%202">Link to this property</a>

const CertificateCASSLCom <a href="https://developers.cloudflare.com/api/go/resources/$shared#(resource)%20%24shared%20%3E%20(model)%20certificate_ca%20%3E%20(schema)">CertificateCA</a> = "ssl\_com"

<a href="#(resource)%20custom_hostnames%20%3E%20(method)%20create%20%3E%20(params)%20default%20%3E%20(param)%20ssl%20%3E%20(schema)%20%3E%20(property)%20certificate_authority%20%2B%20(resource)%20%24shared%20%3E%20(model)%20certificate_ca%20%3E%20(schema)%20%3E%20(member)%203">Link to this property</a>

</details>

<a href="#(resource)%20custom_hostnames%20%3E%20(method)%20create%20%3E%20(params)%20default%20%3E%20(param)%20ssl%20%3E%20(schema)%20%3E%20(property)%20certificate_authority">Link to this property</a>

CloudflareBranding boolOptional

Whether or not to add Cloudflare Branding for the order. This will add a subdomain of sni.cloudflaressl.com as the Common Name if set to true.

<a href="#(resource)%20custom_hostnames%20%3E%20(method)%20create%20%3E%20(params)%20default%20%3E%20(param)%20ssl%20%3E%20(schema)%20%3E%20(property)%20cloudflare_branding">Link to this property</a>

<details>

<summary>

CustomCERTBundle \[]CustomHostnameNewParamsSSLCustomCERTBundleOptional

Array of custom certificate and key pairs (1 or 2 pairs allowed).

</summary>

CustomCertificate string

If a custom uploaded certificate is used.

<a href="#(resource)%20custom_hostnames%20%3E%20(method)%20create%20%3E%20(params)%20default%20%3E%20(param)%20ssl%20%3E%20(schema)%20%3E%20(property)%20custom_cert_bundle%20%3E%20(items)%20%3E%20(property)%20custom_certificate">Link to this property</a>

CustomKey string

The key for a custom uploaded certificate.

<a href="#(resource)%20custom_hostnames%20%3E%20(method)%20create%20%3E%20(params)%20default%20%3E%20(param)%20ssl%20%3E%20(schema)%20%3E%20(property)%20custom_cert_bundle%20%3E%20(items)%20%3E%20(property)%20custom_key">Link to this property</a>

</details>

<a href="#(resource)%20custom_hostnames%20%3E%20(method)%20create%20%3E%20(params)%20default%20%3E%20(param)%20ssl%20%3E%20(schema)%20%3E%20(property)%20custom_cert_bundle">Link to this property</a>

CustomCertificate stringOptional

If a custom uploaded certificate is used.

<a href="#(resource)%20custom_hostnames%20%3E%20(method)%20create%20%3E%20(params)%20default%20%3E%20(param)%20ssl%20%3E%20(schema)%20%3E%20(property)%20custom_certificate">Link to this property</a>

CustomCsrID stringOptional

The identifier for the Custom CSR that was used.

<a href="#(resource)%20custom_hostnames%20%3E%20(method)%20create%20%3E%20(params)%20default%20%3E%20(param)%20ssl%20%3E%20(schema)%20%3E%20(property)%20custom_csr_id">Link to this property</a>

CustomKey stringOptional

The key for a custom uploaded certificate.

<a href="#(resource)%20custom_hostnames%20%3E%20(method)%20create%20%3E%20(params)%20default%20%3E%20(param)%20ssl%20%3E%20(schema)%20%3E%20(property)%20custom_key">Link to this property</a>

<details>

<summary>

Method <a href="https://developers.cloudflare.com/api/go/resources/custom_hostnames#(resource)%20custom_hostnames%20%3E%20(model)%20dcv_method%20%3E%20(schema)">DCVMethod</a>Optional

Domain control validation (DCV) method used for this hostname.

</summary>

One of the following:

const DCVMethodHTTP <a href="https://developers.cloudflare.com/api/go/resources/custom_hostnames#(resource)%20custom_hostnames%20%3E%20(model)%20dcv_method%20%3E%20(schema)">DCVMethod</a> = "http"

<a href="#(resource)%20custom_hostnames%20%3E%20(method)%20create%20%3E%20(params)%20default%20%3E%20(param)%20ssl%20%3E%20(schema)%20%3E%20(property)%20method%20%2B%20(resource)%20custom_hostnames%20%3E%20(model)%20dcv_method%20%3E%20(schema)%20%3E%20(member)%200">Link to this property</a>

const DCVMethodTXT <a href="https://developers.cloudflare.com/api/go/resources/custom_hostnames#(resource)%20custom_hostnames%20%3E%20(model)%20dcv_method%20%3E%20(schema)">DCVMethod</a> = "txt"

<a href="#(resource)%20custom_hostnames%20%3E%20(method)%20create%20%3E%20(params)%20default%20%3E%20(param)%20ssl%20%3E%20(schema)%20%3E%20(property)%20method%20%2B%20(resource)%20custom_hostnames%20%3E%20(model)%20dcv_method%20%3E%20(schema)%20%3E%20(member)%201">Link to this property</a>

const DCVMethodEmail <a href="https://developers.cloudflare.com/api/go/resources/custom_hostnames#(resource)%20custom_hostnames%20%3E%20(model)%20dcv_method%20%3E%20(schema)">DCVMethod</a> = "email"

<a href="#(resource)%20custom_hostnames%20%3E%20(method)%20create%20%3E%20(params)%20default%20%3E%20(param)%20ssl%20%3E%20(schema)%20%3E%20(property)%20method%20%2B%20(resource)%20custom_hostnames%20%3E%20(model)%20dcv_method%20%3E%20(schema)%20%3E%20(member)%202">Link to this property</a>

</details>

<a href="#(resource)%20custom_hostnames%20%3E%20(method)%20create%20%3E%20(params)%20default%20%3E%20(param)%20ssl%20%3E%20(schema)%20%3E%20(property)%20method">Link to this property</a>

<details>

<summary>

Settings CustomHostnameNewParamsSSLSettingsOptional

SSL specific settings.

</summary>

Ciphers \[]stringOptional

An allowlist of ciphers for TLS termination. These ciphers must be in the BoringSSL format.

<a href="#(resource)%20custom_hostnames%20%3E%20(method)%20create%20%3E%20(params)%20default%20%3E%20(param)%20ssl%20%3E%20(schema)%20%3E%20(property)%20settings%20%3E%20(property)%20ciphers">Link to this property</a>

<details>

<summary>

EarlyHints CustomHostnameNewParamsSSLSettingsEarlyHintsOptional

Whether or not Early Hints is enabled.

</summary>

One of the following:

const CustomHostnameNewParamsSSLSettingsEarlyHintsOn CustomHostnameNewParamsSSLSettingsEarlyHints = "on"

<a href="#(resource)%20custom_hostnames%20%3E%20(method)%20create%20%3E%20(params)%20default%20%3E%20(param)%20ssl%20%3E%20(schema)%20%3E%20(property)%20settings%20%3E%20(property)%20early_hints%20%3E%20(member)%200">Link to this property</a>

const CustomHostnameNewParamsSSLSettingsEarlyHintsOff CustomHostnameNewParamsSSLSettingsEarlyHints = "off"

<a href="#(resource)%20custom_hostnames%20%3E%20(method)%20create%20%3E%20(params)%20default%20%3E%20(param)%20ssl%20%3E%20(schema)%20%3E%20(property)%20settings%20%3E%20(property)%20early_hints%20%3E%20(member)%201">Link to this property</a>

</details>

<a href="#(resource)%20custom_hostnames%20%3E%20(method)%20create%20%3E%20(params)%20default%20%3E%20(param)%20ssl%20%3E%20(schema)%20%3E%20(property)%20settings%20%3E%20(property)%20early_hints">Link to this property</a>

<details>

<summary>

HTTP2 CustomHostnameNewParamsSSLSettingsHTTP2Optional

Whether or not HTTP2 is enabled.

</summary>

One of the following:

const CustomHostnameNewParamsSSLSettingsHTTP2On CustomHostnameNewParamsSSLSettingsHTTP2 = "on"

<a href="#(resource)%20custom_hostnames%20%3E%20(method)%20create%20%3E%20(params)%20default%20%3E%20(param)%20ssl%20%3E%20(schema)%20%3E%20(property)%20settings%20%3E%20(property)%20http2%20%3E%20(member)%200">Link to this property</a>

const CustomHostnameNewParamsSSLSettingsHTTP2Off CustomHostnameNewParamsSSLSettingsHTTP2 = "off"

<a href="#(resource)%20custom_hostnames%20%3E%20(method)%20create%20%3E%20(params)%20default%20%3E%20(param)%20ssl%20%3E%20(schema)%20%3E%20(property)%20settings%20%3E%20(property)%20http2%20%3E%20(member)%201">Link to this property</a>

</details>

<a href="#(resource)%20custom_hostnames%20%3E%20(method)%20create%20%3E%20(params)%20default%20%3E%20(param)%20ssl%20%3E%20(schema)%20%3E%20(property)%20settings%20%3E%20(property)%20http2">Link to this property</a>

<details>

<summary>

MinTLSVersion CustomHostnameNewParamsSSLSettingsMinTLSVersionOptional

The minimum TLS version supported.

</summary>

One of the following:

const CustomHostnameNewParamsSSLSettingsMinTLSVersion1\_0 CustomHostnameNewParamsSSLSettingsMinTLSVersion = "1.0"

<a href="#(resource)%20custom_hostnames%20%3E%20(method)%20create%20%3E%20(params)%20default%20%3E%20(param)%20ssl%20%3E%20(schema)%20%3E%20(property)%20settings%20%3E%20(property)%20min_tls_version%20%3E%20(member)%200">Link to this property</a>

const CustomHostnameNewParamsSSLSettingsMinTLSVersion1\_1 CustomHostnameNewParamsSSLSettingsMinTLSVersion = "1.1"

<a href="#(resource)%20custom_hostnames%20%3E%20(method)%20create%20%3E%20(params)%20default%20%3E%20(param)%20ssl%20%3E%20(schema)%20%3E%20(property)%20settings%20%3E%20(property)%20min_tls_version%20%3E%20(member)%201">Link to this property</a>

const CustomHostnameNewParamsSSLSettingsMinTLSVersion1\_2 CustomHostnameNewParamsSSLSettingsMinTLSVersion = "1.2"

<a href="#(resource)%20custom_hostnames%20%3E%20(method)%20create%20%3E%20(params)%20default%20%3E%20(param)%20ssl%20%3E%20(schema)%20%3E%20(property)%20settings%20%3E%20(property)%20min_tls_version%20%3E%20(member)%202">Link to this property</a>

const CustomHostnameNewParamsSSLSettingsMinTLSVersion1\_3 CustomHostnameNewParamsSSLSettingsMinTLSVersion = "1.3"

<a href="#(resource)%20custom_hostnames%20%3E%20(method)%20create%20%3E%20(params)%20default%20%3E%20(param)%20ssl%20%3E%20(schema)%20%3E%20(property)%20settings%20%3E%20(property)%20min_tls_version%20%3E%20(member)%203">Link to this property</a>

</details>

<a href="#(resource)%20custom_hostnames%20%3E%20(method)%20create%20%3E%20(params)%20default%20%3E%20(param)%20ssl%20%3E%20(schema)%20%3E%20(property)%20settings%20%3E%20(property)%20min_tls_version">Link to this property</a>

<details>

<summary>

TLS1\_3 CustomHostnameNewParamsSSLSettingsTLS1\_3Optional

Whether or not TLS 1.3 is enabled.

</summary>

One of the following:

const CustomHostnameNewParamsSSLSettingsTLS1\_3On CustomHostnameNewParamsSSLSettingsTLS1\_3 = "on"

<a href="#(resource)%20custom_hostnames%20%3E%20(method)%20create%20%3E%20(params)%20default%20%3E%20(param)%20ssl%20%3E%20(schema)%20%3E%20(property)%20settings%20%3E%20(property)%20tls_1_3%20%3E%20(member)%200">Link to this property</a>

const CustomHostnameNewParamsSSLSettingsTLS1\_3Off CustomHostnameNewParamsSSLSettingsTLS1\_3 = "off"

<a href="#(resource)%20custom_hostnames%20%3E%20(method)%20create%20%3E%20(params)%20default%20%3E%20(param)%20ssl%20%3E%20(schema)%20%3E%20(property)%20settings%20%3E%20(property)%20tls_1_3%20%3E%20(member)%201">Link to this property</a>

</details>

<a href="#(resource)%20custom_hostnames%20%3E%20(method)%20create%20%3E%20(params)%20default%20%3E%20(param)%20ssl%20%3E%20(schema)%20%3E%20(property)%20settings%20%3E%20(property)%20tls_1_3">Link to this property</a>

</details>

<a href="#(resource)%20custom_hostnames%20%3E%20(method)%20create%20%3E%20(params)%20default%20%3E%20(param)%20ssl%20%3E%20(schema)%20%3E%20(property)%20settings">Link to this property</a>

Type <a href="https://developers.cloudflare.com/api/go/resources/custom_hostnames#(resource)%20custom_hostnames%20%3E%20(model)%20domain_validation_type%20%3E%20(schema)">DomainValidationType</a>Optional

Level of validation to be used for this hostname. Domain validation (dv) must be used.

<a href="#(resource)%20custom_hostnames%20%3E%20(method)%20create%20%3E%20(params)%20default%20%3E%20(param)%20ssl%20%3E%20(schema)%20%3E%20(property)%20type">Link to this property</a>

Wildcard boolOptional

Indicates whether the certificate covers a wildcard.

<a href="#(resource)%20custom_hostnames%20%3E%20(method)%20create%20%3E%20(params)%20default%20%3E%20(param)%20ssl%20%3E%20(schema)%20%3E%20(property)%20wildcard">Link to this property</a>

</details>

<a href="#(resource)%20custom_hostnames%20%3E%20(method)%20create%20%3E%20(params)%20default%20%3E%20(param)%20ssl">Link to this property</a>

</details>

[Link to this property](<#(resource)%20custom_hostnames%20%3E%20(method)%20create%20%3E%20(params)%20default>)

##### ReturnsExpand Collapse

<details>

<summary>

type CustomHostnameNewResponse struct{…}

</summary>

ID string

Custom hostname identifier tag.

maxLength36

minLength36

<a href="#(resource)%20custom_hostnames%20%3E%20(model)%20CustomHostnameNewResponse%20%3E%20(schema)%20%3E%20(property)%20id">Link to this property</a>

Hostname string

The custom hostname that will point to your hostname via CNAME.

maxLength255

<a href="#(resource)%20custom_hostnames%20%3E%20(model)%20CustomHostnameNewResponse%20%3E%20(schema)%20%3E%20(property)%20hostname">Link to this property</a>

CreatedAt TimeOptional

This is the time the hostname was created.

formatdate-time

<a href="#(resource)%20custom_hostnames%20%3E%20(model)%20CustomHostnameNewResponse%20%3E%20(schema)%20%3E%20(property)%20created_at">Link to this property</a>

CustomMetadata map\[string, string]Optional

Unique key/value metadata for this hostname. These are per-hostname (customer) settings.

<a href="#(resource)%20custom_hostnames%20%3E%20(model)%20CustomHostnameNewResponse%20%3E%20(schema)%20%3E%20(property)%20custom_metadata">Link to this property</a>

CustomOriginServer stringOptional

a valid hostname that’s been added to your DNS zone as an A, AAAA, or CNAME record.

<a href="#(resource)%20custom_hostnames%20%3E%20(model)%20CustomHostnameNewResponse%20%3E%20(schema)%20%3E%20(property)%20custom_origin_server">Link to this property</a>

CustomOriginSNI stringOptional

A hostname that will be sent to your custom origin server as SNI for TLS handshake. This can be a valid subdomain of the zone or custom origin server name or the string ‘:request\_host\_header:’ which will cause the host header in the request to be used as SNI. Not configurable with default/fallback origin server.

<a href="#(resource)%20custom_hostnames%20%3E%20(model)%20CustomHostnameNewResponse%20%3E%20(schema)%20%3E%20(property)%20custom_origin_sni">Link to this property</a>

<details>

<summary>

OwnershipVerification CustomHostnameNewResponseOwnershipVerificationOptional

This is a record which can be placed to activate a hostname.

</summary>

Name stringOptional

DNS Name for record.

<a href="#(resource)%20custom_hostnames%20%3E%20(model)%20CustomHostnameNewResponse%20%3E%20(schema)%20%3E%20(property)%20ownership_verification%20%3E%20(property)%20name">Link to this property</a>

Type CustomHostnameNewResponseOwnershipVerificationTypeOptional

DNS Record type.

<a href="#(resource)%20custom_hostnames%20%3E%20(model)%20CustomHostnameNewResponse%20%3E%20(schema)%20%3E%20(property)%20ownership_verification%20%3E%20(property)%20type">Link to this property</a>

Value stringOptional

Content for the record.

<a href="#(resource)%20custom_hostnames%20%3E%20(model)%20CustomHostnameNewResponse%20%3E%20(schema)%20%3E%20(property)%20ownership_verification%20%3E%20(property)%20value">Link to this property</a>

</details>

<a href="#(resource)%20custom_hostnames%20%3E%20(model)%20CustomHostnameNewResponse%20%3E%20(schema)%20%3E%20(property)%20ownership_verification">Link to this property</a>

<details>

<summary>

OwnershipVerificationHTTP CustomHostnameNewResponseOwnershipVerificationHTTPOptional

This presents the token to be served by the given http url to activate a hostname.

</summary>

HTTPBody stringOptional

Token to be served.

<a href="#(resource)%20custom_hostnames%20%3E%20(model)%20CustomHostnameNewResponse%20%3E%20(schema)%20%3E%20(property)%20ownership_verification_http%20%3E%20(property)%20http_body">Link to this property</a>

HTTPURL stringOptional

The HTTP URL that will be checked during custom hostname verification and where the customer should host the token.

<a href="#(resource)%20custom_hostnames%20%3E%20(model)%20CustomHostnameNewResponse%20%3E%20(schema)%20%3E%20(property)%20ownership_verification_http%20%3E%20(property)%20http_url">Link to this property</a>

</details>

<a href="#(resource)%20custom_hostnames%20%3E%20(model)%20CustomHostnameNewResponse%20%3E%20(schema)%20%3E%20(property)%20ownership_verification_http">Link to this property</a>

<details>

<summary>

SSL CustomHostnameNewResponseSSLOptional

</summary>

ID stringOptional

Custom hostname SSL identifier tag.

maxLength36

minLength36

<a href="#(resource)%20custom_hostnames%20%3E%20(model)%20CustomHostnameNewResponse%20%3E%20(schema)%20%3E%20(property)%20ssl%20%3E%20(property)%20id">Link to this property</a>

<details>

<summary>

BundleMethod <a href="https://developers.cloudflare.com/api/go/resources/custom_hostnames#(resource)%20custom_hostnames%20%3E%20(model)%20bundle_method%20%3E%20(schema)">BundleMethod</a>Optional

A ubiquitous bundle has the highest probability of being verified everywhere, even by clients using outdated or unusual trust stores. An optimal bundle uses the shortest chain and newest intermediates. And the force bundle verifies the chain, but does not otherwise modify it.

</summary>

One of the following:

const BundleMethodUbiquitous <a href="https://developers.cloudflare.com/api/go/resources/custom_hostnames#(resource)%20custom_hostnames%20%3E%20(model)%20bundle_method%20%3E%20(schema)">BundleMethod</a> = "ubiquitous"

<a href="#(resource)%20custom_hostnames%20%3E%20(model)%20CustomHostnameNewResponse%20%3E%20(schema)%20%3E%20(property)%20ssl%20%3E%20(property)%20bundle_method%20%2B%20(resource)%20custom_hostnames%20%3E%20(model)%20bundle_method%20%3E%20(schema)%20%3E%20(member)%200">Link to this property</a>

const BundleMethodOptimal <a href="https://developers.cloudflare.com/api/go/resources/custom_hostnames#(resource)%20custom_hostnames%20%3E%20(model)%20bundle_method%20%3E%20(schema)">BundleMethod</a> = "optimal"

<a href="#(resource)%20custom_hostnames%20%3E%20(model)%20CustomHostnameNewResponse%20%3E%20(schema)%20%3E%20(property)%20ssl%20%3E%20(property)%20bundle_method%20%2B%20(resource)%20custom_hostnames%20%3E%20(model)%20bundle_method%20%3E%20(schema)%20%3E%20(member)%201">Link to this property</a>

const BundleMethodForce <a href="https://developers.cloudflare.com/api/go/resources/custom_hostnames#(resource)%20custom_hostnames%20%3E%20(model)%20bundle_method%20%3E%20(schema)">BundleMethod</a> = "force"

<a href="#(resource)%20custom_hostnames%20%3E%20(model)%20CustomHostnameNewResponse%20%3E%20(schema)%20%3E%20(property)%20ssl%20%3E%20(property)%20bundle_method%20%2B%20(resource)%20custom_hostnames%20%3E%20(model)%20bundle_method%20%3E%20(schema)%20%3E%20(member)%202">Link to this property</a>

</details>

<a href="#(resource)%20custom_hostnames%20%3E%20(model)%20CustomHostnameNewResponse%20%3E%20(schema)%20%3E%20(property)%20ssl%20%3E%20(property)%20bundle_method">Link to this property</a>

<details>

<summary>

CertificateAuthority <a href="https://developers.cloudflare.com/api/go/resources/$shared#(resource)%20%24shared%20%3E%20(model)%20certificate_ca%20%3E%20(schema)">CertificateCA</a>Optional

The Certificate Authority that will issue the certificate.

</summary>

One of the following:

const CertificateCADigicert <a href="https://developers.cloudflare.com/api/go/resources/$shared#(resource)%20%24shared%20%3E%20(model)%20certificate_ca%20%3E%20(schema)">CertificateCA</a> = "digicert"

<a href="#(resource)%20custom_hostnames%20%3E%20(model)%20CustomHostnameNewResponse%20%3E%20(schema)%20%3E%20(property)%20ssl%20%3E%20(property)%20certificate_authority%20%2B%20(resource)%20%24shared%20%3E%20(model)%20certificate_ca%20%3E%20(schema)%20%3E%20(member)%200">Link to this property</a>

const CertificateCAGoogle <a href="https://developers.cloudflare.com/api/go/resources/$shared#(resource)%20%24shared%20%3E%20(model)%20certificate_ca%20%3E%20(schema)">CertificateCA</a> = "google"

<a href="#(resource)%20custom_hostnames%20%3E%20(model)%20CustomHostnameNewResponse%20%3E%20(schema)%20%3E%20(property)%20ssl%20%3E%20(property)%20certificate_authority%20%2B%20(resource)%20%24shared%20%3E%20(model)%20certificate_ca%20%3E%20(schema)%20%3E%20(member)%201">Link to this property</a>

const CertificateCALetsEncrypt <a href="https://developers.cloudflare.com/api/go/resources/$shared#(resource)%20%24shared%20%3E%20(model)%20certificate_ca%20%3E%20(schema)">CertificateCA</a> = "lets\_encrypt"

<a href="#(resource)%20custom_hostnames%20%3E%20(model)%20CustomHostnameNewResponse%20%3E%20(schema)%20%3E%20(property)%20ssl%20%3E%20(property)%20certificate_authority%20%2B%20(resource)%20%24shared%20%3E%20(model)%20certificate_ca%20%3E%20(schema)%20%3E%20(member)%202">Link to this property</a>

const CertificateCASSLCom <a href="https://developers.cloudflare.com/api/go/resources/$shared#(resource)%20%24shared%20%3E%20(model)%20certificate_ca%20%3E%20(schema)">CertificateCA</a> = "ssl\_com"

<a href="#(resource)%20custom_hostnames%20%3E%20(model)%20CustomHostnameNewResponse%20%3E%20(schema)%20%3E%20(property)%20ssl%20%3E%20(property)%20certificate_authority%20%2B%20(resource)%20%24shared%20%3E%20(model)%20certificate_ca%20%3E%20(schema)%20%3E%20(member)%203">Link to this property</a>

</details>

<a href="#(resource)%20custom_hostnames%20%3E%20(model)%20CustomHostnameNewResponse%20%3E%20(schema)%20%3E%20(property)%20ssl%20%3E%20(property)%20certificate_authority">Link to this property</a>

CustomCertificate stringOptional

If a custom uploaded certificate is used.

<a href="#(resource)%20custom_hostnames%20%3E%20(model)%20CustomHostnameNewResponse%20%3E%20(schema)%20%3E%20(property)%20ssl%20%3E%20(property)%20custom_certificate">Link to this property</a>

CustomCsrID stringOptional

The identifier for the Custom CSR that was used.

<a href="#(resource)%20custom_hostnames%20%3E%20(model)%20CustomHostnameNewResponse%20%3E%20(schema)%20%3E%20(property)%20ssl%20%3E%20(property)%20custom_csr_id">Link to this property</a>

CustomKey stringOptional

The key for a custom uploaded certificate.

<a href="#(resource)%20custom_hostnames%20%3E%20(model)%20CustomHostnameNewResponse%20%3E%20(schema)%20%3E%20(property)%20ssl%20%3E%20(property)%20custom_key">Link to this property</a>

<details>

<summary>

DCVDelegationRecords \[]CustomHostnameNewResponseSsldcvDelegationRecordOptional

DCV Delegation records for domain validation.

</summary>

CNAME stringOptional

The CNAME record hostname for DCV delegation.

<a href="#(resource)%20custom_hostnames%20%3E%20(model)%20CustomHostnameNewResponse%20%3E%20(schema)%20%3E%20(property)%20ssl%20%3E%20(property)%20dcv_delegation_records%20%3E%20(items)%20%3E%20(property)%20cname">Link to this property</a>

CNAMETarget stringOptional

The CNAME record target value for DCV delegation.

<a href="#(resource)%20custom_hostnames%20%3E%20(model)%20CustomHostnameNewResponse%20%3E%20(schema)%20%3E%20(property)%20ssl%20%3E%20(property)%20dcv_delegation_records%20%3E%20(items)%20%3E%20(property)%20cname_target">Link to this property</a>

Emails \[]stringOptional

The set of email addresses that the certificate authority (CA) will use to complete domain validation.

<a href="#(resource)%20custom_hostnames%20%3E%20(model)%20CustomHostnameNewResponse%20%3E%20(schema)%20%3E%20(property)%20ssl%20%3E%20(property)%20dcv_delegation_records%20%3E%20(items)%20%3E%20(property)%20emails">Link to this property</a>

HTTPBody stringOptional

The content that the certificate authority (CA) will expect to find at the http\_url during the domain validation.

<a href="#(resource)%20custom_hostnames%20%3E%20(model)%20CustomHostnameNewResponse%20%3E%20(schema)%20%3E%20(property)%20ssl%20%3E%20(property)%20dcv_delegation_records%20%3E%20(items)%20%3E%20(property)%20http_body">Link to this property</a>

HTTPURL stringOptional

The url that will be checked during domain validation.

<a href="#(resource)%20custom_hostnames%20%3E%20(model)%20CustomHostnameNewResponse%20%3E%20(schema)%20%3E%20(property)%20ssl%20%3E%20(property)%20dcv_delegation_records%20%3E%20(items)%20%3E%20(property)%20http_url">Link to this property</a>

Status stringOptional

Status of the validation record.

<a href="#(resource)%20custom_hostnames%20%3E%20(model)%20CustomHostnameNewResponse%20%3E%20(schema)%20%3E%20(property)%20ssl%20%3E%20(property)%20dcv_delegation_records%20%3E%20(items)%20%3E%20(property)%20status">Link to this property</a>

TXTName stringOptional

The hostname that the certificate authority (CA) will check for a TXT record during domain validation .

<a href="#(resource)%20custom_hostnames%20%3E%20(model)%20CustomHostnameNewResponse%20%3E%20(schema)%20%3E%20(property)%20ssl%20%3E%20(property)%20dcv_delegation_records%20%3E%20(items)%20%3E%20(property)%20txt_name">Link to this property</a>

TXTValue stringOptional

The TXT record that the certificate authority (CA) will check during domain validation.

<a href="#(resource)%20custom_hostnames%20%3E%20(model)%20CustomHostnameNewResponse%20%3E%20(schema)%20%3E%20(property)%20ssl%20%3E%20(property)%20dcv_delegation_records%20%3E%20(items)%20%3E%20(property)%20txt_value">Link to this property</a>

</details>

<a href="#(resource)%20custom_hostnames%20%3E%20(model)%20CustomHostnameNewResponse%20%3E%20(schema)%20%3E%20(property)%20ssl%20%3E%20(property)%20dcv_delegation_records">Link to this property</a>

ExpiresOn TimeOptional

The time the custom certificate expires on.

formatdate-time

<a href="#(resource)%20custom_hostnames%20%3E%20(model)%20CustomHostnameNewResponse%20%3E%20(schema)%20%3E%20(property)%20ssl%20%3E%20(property)%20expires_on">Link to this property</a>

Hosts \[]stringOptional

A list of Hostnames on a custom uploaded certificate.

<a href="#(resource)%20custom_hostnames%20%3E%20(model)%20CustomHostnameNewResponse%20%3E%20(schema)%20%3E%20(property)%20ssl%20%3E%20(property)%20hosts">Link to this property</a>

Issuer stringOptional

The issuer on a custom uploaded certificate.

<a href="#(resource)%20custom_hostnames%20%3E%20(model)%20CustomHostnameNewResponse%20%3E%20(schema)%20%3E%20(property)%20ssl%20%3E%20(property)%20issuer">Link to this property</a>

<details>

<summary>

Method <a href="https://developers.cloudflare.com/api/go/resources/custom_hostnames#(resource)%20custom_hostnames%20%3E%20(model)%20dcv_method%20%3E%20(schema)">DCVMethod</a>Optional

Domain control validation (DCV) method used for this hostname.

</summary>

One of the following:

const DCVMethodHTTP <a href="https://developers.cloudflare.com/api/go/resources/custom_hostnames#(resource)%20custom_hostnames%20%3E%20(model)%20dcv_method%20%3E%20(schema)">DCVMethod</a> = "http"

<a href="#(resource)%20custom_hostnames%20%3E%20(model)%20CustomHostnameNewResponse%20%3E%20(schema)%20%3E%20(property)%20ssl%20%3E%20(property)%20method%20%2B%20(resource)%20custom_hostnames%20%3E%20(model)%20dcv_method%20%3E%20(schema)%20%3E%20(member)%200">Link to this property</a>

const DCVMethodTXT <a href="https://developers.cloudflare.com/api/go/resources/custom_hostnames#(resource)%20custom_hostnames%20%3E%20(model)%20dcv_method%20%3E%20(schema)">DCVMethod</a> = "txt"

<a href="#(resource)%20custom_hostnames%20%3E%20(model)%20CustomHostnameNewResponse%20%3E%20(schema)%20%3E%20(property)%20ssl%20%3E%20(property)%20method%20%2B%20(resource)%20custom_hostnames%20%3E%20(model)%20dcv_method%20%3E%20(schema)%20%3E%20(member)%201">Link to this property</a>

const DCVMethodEmail <a href="https://developers.cloudflare.com/api/go/resources/custom_hostnames#(resource)%20custom_hostnames%20%3E%20(model)%20dcv_method%20%3E%20(schema)">DCVMethod</a> = "email"

<a href="#(resource)%20custom_hostnames%20%3E%20(model)%20CustomHostnameNewResponse%20%3E%20(schema)%20%3E%20(property)%20ssl%20%3E%20(property)%20method%20%2B%20(resource)%20custom_hostnames%20%3E%20(model)%20dcv_method%20%3E%20(schema)%20%3E%20(member)%202">Link to this property</a>

</details>

<a href="#(resource)%20custom_hostnames%20%3E%20(model)%20CustomHostnameNewResponse%20%3E%20(schema)%20%3E%20(property)%20ssl%20%3E%20(property)%20method">Link to this property</a>

SerialNumber stringOptional

The serial number on a custom uploaded certificate.

<a href="#(resource)%20custom_hostnames%20%3E%20(model)%20CustomHostnameNewResponse%20%3E%20(schema)%20%3E%20(property)%20ssl%20%3E%20(property)%20serial_number">Link to this property</a>

<details>

<summary>

Settings CustomHostnameNewResponseSSLSettingsOptional

</summary>

Ciphers \[]stringOptional

An allowlist of ciphers for TLS termination. These ciphers must be in the BoringSSL format.

<a href="#(resource)%20custom_hostnames%20%3E%20(model)%20CustomHostnameNewResponse%20%3E%20(schema)%20%3E%20(property)%20ssl%20%3E%20(property)%20settings%20%3E%20(property)%20ciphers">Link to this property</a>

<details>

<summary>

EarlyHints CustomHostnameNewResponseSSLSettingsEarlyHintsOptional

Whether or not Early Hints is enabled.

</summary>

One of the following:

const CustomHostnameNewResponseSSLSettingsEarlyHintsOn CustomHostnameNewResponseSSLSettingsEarlyHints = "on"

<a href="#(resource)%20custom_hostnames%20%3E%20(model)%20CustomHostnameNewResponse%20%3E%20(schema)%20%3E%20(property)%20ssl%20%3E%20(property)%20settings%20%3E%20(property)%20early_hints%20%3E%20(member)%200">Link to this property</a>

const CustomHostnameNewResponseSSLSettingsEarlyHintsOff CustomHostnameNewResponseSSLSettingsEarlyHints = "off"

<a href="#(resource)%20custom_hostnames%20%3E%20(model)%20CustomHostnameNewResponse%20%3E%20(schema)%20%3E%20(property)%20ssl%20%3E%20(property)%20settings%20%3E%20(property)%20early_hints%20%3E%20(member)%201">Link to this property</a>

</details>

<a href="#(resource)%20custom_hostnames%20%3E%20(model)%20CustomHostnameNewResponse%20%3E%20(schema)%20%3E%20(property)%20ssl%20%3E%20(property)%20settings%20%3E%20(property)%20early_hints">Link to this property</a>

<details>

<summary>

HTTP2 CustomHostnameNewResponseSSLSettingsHTTP2Optional

Whether or not HTTP2 is enabled.

</summary>

One of the following:

const CustomHostnameNewResponseSSLSettingsHTTP2On CustomHostnameNewResponseSSLSettingsHTTP2 = "on"

<a href="#(resource)%20custom_hostnames%20%3E%20(model)%20CustomHostnameNewResponse%20%3E%20(schema)%20%3E%20(property)%20ssl%20%3E%20(property)%20settings%20%3E%20(property)%20http2%20%3E%20(member)%200">Link to this property</a>

const CustomHostnameNewResponseSSLSettingsHTTP2Off CustomHostnameNewResponseSSLSettingsHTTP2 = "off"

<a href="#(resource)%20custom_hostnames%20%3E%20(model)%20CustomHostnameNewResponse%20%3E%20(schema)%20%3E%20(property)%20ssl%20%3E%20(property)%20settings%20%3E%20(property)%20http2%20%3E%20(member)%201">Link to this property</a>

</details>

<a href="#(resource)%20custom_hostnames%20%3E%20(model)%20CustomHostnameNewResponse%20%3E%20(schema)%20%3E%20(property)%20ssl%20%3E%20(property)%20settings%20%3E%20(property)%20http2">Link to this property</a>

<details>

<summary>

MinTLSVersion CustomHostnameNewResponseSSLSettingsMinTLSVersionOptional

The minimum TLS version supported.

</summary>

One of the following:

const CustomHostnameNewResponseSSLSettingsMinTLSVersion1\_0 CustomHostnameNewResponseSSLSettingsMinTLSVersion = "1.0"

<a href="#(resource)%20custom_hostnames%20%3E%20(model)%20CustomHostnameNewResponse%20%3E%20(schema)%20%3E%20(property)%20ssl%20%3E%20(property)%20settings%20%3E%20(property)%20min_tls_version%20%3E%20(member)%200">Link to this property</a>

const CustomHostnameNewResponseSSLSettingsMinTLSVersion1\_1 CustomHostnameNewResponseSSLSettingsMinTLSVersion = "1.1"

<a href="#(resource)%20custom_hostnames%20%3E%20(model)%20CustomHostnameNewResponse%20%3E%20(schema)%20%3E%20(property)%20ssl%20%3E%20(property)%20settings%20%3E%20(property)%20min_tls_version%20%3E%20(member)%201">Link to this property</a>

const CustomHostnameNewResponseSSLSettingsMinTLSVersion1\_2 CustomHostnameNewResponseSSLSettingsMinTLSVersion = "1.2"

<a href="#(resource)%20custom_hostnames%20%3E%20(model)%20CustomHostnameNewResponse%20%3E%20(schema)%20%3E%20(property)%20ssl%20%3E%20(property)%20settings%20%3E%20(property)%20min_tls_version%20%3E%20(member)%202">Link to this property</a>

const CustomHostnameNewResponseSSLSettingsMinTLSVersion1\_3 CustomHostnameNewResponseSSLSettingsMinTLSVersion = "1.3"

<a href="#(resource)%20custom_hostnames%20%3E%20(model)%20CustomHostnameNewResponse%20%3E%20(schema)%20%3E%20(property)%20ssl%20%3E%20(property)%20settings%20%3E%20(property)%20min_tls_version%20%3E%20(member)%203">Link to this property</a>

</details>

<a href="#(resource)%20custom_hostnames%20%3E%20(model)%20CustomHostnameNewResponse%20%3E%20(schema)%20%3E%20(property)%20ssl%20%3E%20(property)%20settings%20%3E%20(property)%20min_tls_version">Link to this property</a>

<details>

<summary>

TLS1\_3 CustomHostnameNewResponseSSLSettingsTLS1\_3Optional

Whether or not TLS 1.3 is enabled.

</summary>

One of the following:

const CustomHostnameNewResponseSSLSettingsTLS1\_3On CustomHostnameNewResponseSSLSettingsTLS1\_3 = "on"

<a href="#(resource)%20custom_hostnames%20%3E%20(model)%20CustomHostnameNewResponse%20%3E%20(schema)%20%3E%20(property)%20ssl%20%3E%20(property)%20settings%20%3E%20(property)%20tls_1_3%20%3E%20(member)%200">Link to this property</a>

const CustomHostnameNewResponseSSLSettingsTLS1\_3Off CustomHostnameNewResponseSSLSettingsTLS1\_3 = "off"

<a href="#(resource)%20custom_hostnames%20%3E%20(model)%20CustomHostnameNewResponse%20%3E%20(schema)%20%3E%20(property)%20ssl%20%3E%20(property)%20settings%20%3E%20(property)%20tls_1_3%20%3E%20(member)%201">Link to this property</a>

</details>

<a href="#(resource)%20custom_hostnames%20%3E%20(model)%20CustomHostnameNewResponse%20%3E%20(schema)%20%3E%20(property)%20ssl%20%3E%20(property)%20settings%20%3E%20(property)%20tls_1_3">Link to this property</a>

</details>

<a href="#(resource)%20custom_hostnames%20%3E%20(model)%20CustomHostnameNewResponse%20%3E%20(schema)%20%3E%20(property)%20ssl%20%3E%20(property)%20settings">Link to this property</a>

Signature stringOptional

The signature on a custom uploaded certificate.

<a href="#(resource)%20custom_hostnames%20%3E%20(model)%20CustomHostnameNewResponse%20%3E%20(schema)%20%3E%20(property)%20ssl%20%3E%20(property)%20signature">Link to this property</a>

<details>

<summary>

Status CustomHostnameNewResponseSSLStatusOptional

Status of the hostname’s SSL certificates.

</summary>

One of the following:

const CustomHostnameNewResponseSSLStatusInitializing CustomHostnameNewResponseSSLStatus = "initializing"

<a href="#(resource)%20custom_hostnames%20%3E%20(model)%20CustomHostnameNewResponse%20%3E%20(schema)%20%3E%20(property)%20ssl%20%3E%20(property)%20status%20%3E%20(member)%200">Link to this property</a>

const CustomHostnameNewResponseSSLStatusPendingValidation CustomHostnameNewResponseSSLStatus = "pending\_validation"

<a href="#(resource)%20custom_hostnames%20%3E%20(model)%20CustomHostnameNewResponse%20%3E%20(schema)%20%3E%20(property)%20ssl%20%3E%20(property)%20status%20%3E%20(member)%201">Link to this property</a>

const CustomHostnameNewResponseSSLStatusDeleted CustomHostnameNewResponseSSLStatus = "deleted"

<a href="#(resource)%20custom_hostnames%20%3E%20(model)%20CustomHostnameNewResponse%20%3E%20(schema)%20%3E%20(property)%20ssl%20%3E%20(property)%20status%20%3E%20(member)%202">Link to this property</a>

const CustomHostnameNewResponseSSLStatusPendingIssuance CustomHostnameNewResponseSSLStatus = "pending\_issuance"

<a href="#(resource)%20custom_hostnames%20%3E%20(model)%20CustomHostnameNewResponse%20%3E%20(schema)%20%3E%20(property)%20ssl%20%3E%20(property)%20status%20%3E%20(member)%203">Link to this property</a>

const CustomHostnameNewResponseSSLStatusPendingDeployment CustomHostnameNewResponseSSLStatus = "pending\_deployment"

<a href="#(resource)%20custom_hostnames%20%3E%20(model)%20CustomHostnameNewResponse%20%3E%20(schema)%20%3E%20(property)%20ssl%20%3E%20(property)%20status%20%3E%20(member)%204">Link to this property</a>

const CustomHostnameNewResponseSSLStatusPendingDeletion CustomHostnameNewResponseSSLStatus = "pending\_deletion"

<a href="#(resource)%20custom_hostnames%20%3E%20(model)%20CustomHostnameNewResponse%20%3E%20(schema)%20%3E%20(property)%20ssl%20%3E%20(property)%20status%20%3E%20(member)%205">Link to this property</a>

const CustomHostnameNewResponseSSLStatusPendingExpiration CustomHostnameNewResponseSSLStatus = "pending\_expiration"

<a href="#(resource)%20custom_hostnames%20%3E%20(model)%20CustomHostnameNewResponse%20%3E%20(schema)%20%3E%20(property)%20ssl%20%3E%20(property)%20status%20%3E%20(member)%206">Link to this property</a>

const CustomHostnameNewResponseSSLStatusExpired CustomHostnameNewResponseSSLStatus = "expired"

<a href="#(resource)%20custom_hostnames%20%3E%20(model)%20CustomHostnameNewResponse%20%3E%20(schema)%20%3E%20(property)%20ssl%20%3E%20(property)%20status%20%3E%20(member)%207">Link to this property</a>

const CustomHostnameNewResponseSSLStatusActive CustomHostnameNewResponseSSLStatus = "active"

<a href="#(resource)%20custom_hostnames%20%3E%20(model)%20CustomHostnameNewResponse%20%3E%20(schema)%20%3E%20(property)%20ssl%20%3E%20(property)%20status%20%3E%20(member)%208">Link to this property</a>

const CustomHostnameNewResponseSSLStatusInitializingTimedOut CustomHostnameNewResponseSSLStatus = "initializing\_timed\_out"

<a href="#(resource)%20custom_hostnames%20%3E%20(model)%20CustomHostnameNewResponse%20%3E%20(schema)%20%3E%20(property)%20ssl%20%3E%20(property)%20status%20%3E%20(member)%209">Link to this property</a>

const CustomHostnameNewResponseSSLStatusValidationTimedOut CustomHostnameNewResponseSSLStatus = "validation\_timed\_out"

<a href="#(resource)%20custom_hostnames%20%3E%20(model)%20CustomHostnameNewResponse%20%3E%20(schema)%20%3E%20(property)%20ssl%20%3E%20(property)%20status%20%3E%20(member)%2010">Link to this property</a>

const CustomHostnameNewResponseSSLStatusIssuanceTimedOut CustomHostnameNewResponseSSLStatus = "issuance\_timed\_out"

<a href="#(resource)%20custom_hostnames%20%3E%20(model)%20CustomHostnameNewResponse%20%3E%20(schema)%20%3E%20(property)%20ssl%20%3E%20(property)%20status%20%3E%20(member)%2011">Link to this property</a>

const CustomHostnameNewResponseSSLStatusDeploymentTimedOut CustomHostnameNewResponseSSLStatus = "deployment\_timed\_out"

<a href="#(resource)%20custom_hostnames%20%3E%20(model)%20CustomHostnameNewResponse%20%3E%20(schema)%20%3E%20(property)%20ssl%20%3E%20(property)%20status%20%3E%20(member)%2012">Link to this property</a>

const CustomHostnameNewResponseSSLStatusDeletionTimedOut CustomHostnameNewResponseSSLStatus = "deletion\_timed\_out"

<a href="#(resource)%20custom_hostnames%20%3E%20(model)%20CustomHostnameNewResponse%20%3E%20(schema)%20%3E%20(property)%20ssl%20%3E%20(property)%20status%20%3E%20(member)%2013">Link to this property</a>

const CustomHostnameNewResponseSSLStatusPendingCleanup CustomHostnameNewResponseSSLStatus = "pending\_cleanup"

<a href="#(resource)%20custom_hostnames%20%3E%20(model)%20CustomHostnameNewResponse%20%3E%20(schema)%20%3E%20(property)%20ssl%20%3E%20(property)%20status%20%3E%20(member)%2014">Link to this property</a>

const CustomHostnameNewResponseSSLStatusStagingDeployment CustomHostnameNewResponseSSLStatus = "staging\_deployment"

<a href="#(resource)%20custom_hostnames%20%3E%20(model)%20CustomHostnameNewResponse%20%3E%20(schema)%20%3E%20(property)%20ssl%20%3E%20(property)%20status%20%3E%20(member)%2015">Link to this property</a>

const CustomHostnameNewResponseSSLStatusStagingActive CustomHostnameNewResponseSSLStatus = "staging\_active"

<a href="#(resource)%20custom_hostnames%20%3E%20(model)%20CustomHostnameNewResponse%20%3E%20(schema)%20%3E%20(property)%20ssl%20%3E%20(property)%20status%20%3E%20(member)%2016">Link to this property</a>

const CustomHostnameNewResponseSSLStatusDeactivating CustomHostnameNewResponseSSLStatus = "deactivating"

<a href="#(resource)%20custom_hostnames%20%3E%20(model)%20CustomHostnameNewResponse%20%3E%20(schema)%20%3E%20(property)%20ssl%20%3E%20(property)%20status%20%3E%20(member)%2017">Link to this property</a>

const CustomHostnameNewResponseSSLStatusInactive CustomHostnameNewResponseSSLStatus = "inactive"

<a href="#(resource)%20custom_hostnames%20%3E%20(model)%20CustomHostnameNewResponse%20%3E%20(schema)%20%3E%20(property)%20ssl%20%3E%20(property)%20status%20%3E%20(member)%2018">Link to this property</a>

const CustomHostnameNewResponseSSLStatusBackupIssued CustomHostnameNewResponseSSLStatus = "backup\_issued"

<a href="#(resource)%20custom_hostnames%20%3E%20(model)%20CustomHostnameNewResponse%20%3E%20(schema)%20%3E%20(property)%20ssl%20%3E%20(property)%20status%20%3E%20(member)%2019">Link to this property</a>

const CustomHostnameNewResponseSSLStatusHoldingDeployment CustomHostnameNewResponseSSLStatus = "holding\_deployment"

<a href="#(resource)%20custom_hostnames%20%3E%20(model)%20CustomHostnameNewResponse%20%3E%20(schema)%20%3E%20(property)%20ssl%20%3E%20(property)%20status%20%3E%20(member)%2020">Link to this property</a>

</details>

<a href="#(resource)%20custom_hostnames%20%3E%20(model)%20CustomHostnameNewResponse%20%3E%20(schema)%20%3E%20(property)%20ssl%20%3E%20(property)%20status">Link to this property</a>

Type <a href="https://developers.cloudflare.com/api/go/resources/custom_hostnames#(resource)%20custom_hostnames%20%3E%20(model)%20domain_validation_type%20%3E%20(schema)">DomainValidationType</a>Optional

Level of validation to be used for this hostname. Domain validation (dv) must be used.

<a href="#(resource)%20custom_hostnames%20%3E%20(model)%20CustomHostnameNewResponse%20%3E%20(schema)%20%3E%20(property)%20ssl%20%3E%20(property)%20type">Link to this property</a>

UploadedOn TimeOptional

The time the custom certificate was uploaded.

formatdate-time

<a href="#(resource)%20custom_hostnames%20%3E%20(model)%20CustomHostnameNewResponse%20%3E%20(schema)%20%3E%20(property)%20ssl%20%3E%20(property)%20uploaded_on">Link to this property</a>

<details>

<summary>

ValidationErrors \[]CustomHostnameNewResponseSSLValidationErrorOptional

Domain validation errors that have been received by the certificate authority (CA).

</summary>

Message stringOptional

A domain validation error.

<a href="#(resource)%20custom_hostnames%20%3E%20(model)%20CustomHostnameNewResponse%20%3E%20(schema)%20%3E%20(property)%20ssl%20%3E%20(property)%20validation_errors%20%3E%20(items)%20%3E%20(property)%20message">Link to this property</a>

</details>

<a href="#(resource)%20custom_hostnames%20%3E%20(model)%20CustomHostnameNewResponse%20%3E%20(schema)%20%3E%20(property)%20ssl%20%3E%20(property)%20validation_errors">Link to this property</a>

<details>

<summary>

ValidationRecords \[]CustomHostnameNewResponseSSLValidationRecordOptional

</summary>

CNAME stringOptional

The CNAME record hostname for DCV delegation.

<a href="#(resource)%20custom_hostnames%20%3E%20(model)%20CustomHostnameNewResponse%20%3E%20(schema)%20%3E%20(property)%20ssl%20%3E%20(property)%20validation_records%20%3E%20(items)%20%3E%20(property)%20cname">Link to this property</a>

CNAMETarget stringOptional

The CNAME record target value for DCV delegation.

<a href="#(resource)%20custom_hostnames%20%3E%20(model)%20CustomHostnameNewResponse%20%3E%20(schema)%20%3E%20(property)%20ssl%20%3E%20(property)%20validation_records%20%3E%20(items)%20%3E%20(property)%20cname_target">Link to this property</a>

Emails \[]stringOptional

The set of email addresses that the certificate authority (CA) will use to complete domain validation.

<a href="#(resource)%20custom_hostnames%20%3E%20(model)%20CustomHostnameNewResponse%20%3E%20(schema)%20%3E%20(property)%20ssl%20%3E%20(property)%20validation_records%20%3E%20(items)%20%3E%20(property)%20emails">Link to this property</a>

HTTPBody stringOptional

The content that the certificate authority (CA) will expect to find at the http\_url during the domain validation.

<a href="#(resource)%20custom_hostnames%20%3E%20(model)%20CustomHostnameNewResponse%20%3E%20(schema)%20%3E%20(property)%20ssl%20%3E%20(property)%20validation_records%20%3E%20(items)%20%3E%20(property)%20http_body">Link to this property</a>

HTTPURL stringOptional

The url that will be checked during domain validation.

<a href="#(resource)%20custom_hostnames%20%3E%20(model)%20CustomHostnameNewResponse%20%3E%20(schema)%20%3E%20(property)%20ssl%20%3E%20(property)%20validation_records%20%3E%20(items)%20%3E%20(property)%20http_url">Link to this property</a>

Status stringOptional

Status of the validation record.

<a href="#(resource)%20custom_hostnames%20%3E%20(model)%20CustomHostnameNewResponse%20%3E%20(schema)%20%3E%20(property)%20ssl%20%3E%20(property)%20validation_records%20%3E%20(items)%20%3E%20(property)%20status">Link to this property</a>

TXTName stringOptional

The hostname that the certificate authority (CA) will check for a TXT record during domain validation .

<a href="#(resource)%20custom_hostnames%20%3E%20(model)%20CustomHostnameNewResponse%20%3E%20(schema)%20%3E%20(property)%20ssl%20%3E%20(property)%20validation_records%20%3E%20(items)%20%3E%20(property)%20txt_name">Link to this property</a>

TXTValue stringOptional

The TXT record that the certificate authority (CA) will check during domain validation.

<a href="#(resource)%20custom_hostnames%20%3E%20(model)%20CustomHostnameNewResponse%20%3E%20(schema)%20%3E%20(property)%20ssl%20%3E%20(property)%20validation_records%20%3E%20(items)%20%3E%20(property)%20txt_value">Link to this property</a>

</details>

<a href="#(resource)%20custom_hostnames%20%3E%20(model)%20CustomHostnameNewResponse%20%3E%20(schema)%20%3E%20(property)%20ssl%20%3E%20(property)%20validation_records">Link to this property</a>

Wildcard boolOptional

Indicates whether the certificate covers a wildcard.

<a href="#(resource)%20custom_hostnames%20%3E%20(model)%20CustomHostnameNewResponse%20%3E%20(schema)%20%3E%20(property)%20ssl%20%3E%20(property)%20wildcard">Link to this property</a>

</details>

<a href="#(resource)%20custom_hostnames%20%3E%20(model)%20CustomHostnameNewResponse%20%3E%20(schema)%20%3E%20(property)%20ssl">Link to this property</a>

<details>

<summary>

Status CustomHostnameNewResponseStatusOptional

Status of the hostname’s activation.

</summary>

One of the following:

const CustomHostnameNewResponseStatusActive CustomHostnameNewResponseStatus = "active"

<a href="#(resource)%20custom_hostnames%20%3E%20(model)%20CustomHostnameNewResponse%20%3E%20(schema)%20%3E%20(property)%20status%20%3E%20(member)%200">Link to this property</a>

const CustomHostnameNewResponseStatusPending CustomHostnameNewResponseStatus = "pending"

<a href="#(resource)%20custom_hostnames%20%3E%20(model)%20CustomHostnameNewResponse%20%3E%20(schema)%20%3E%20(property)%20status%20%3E%20(member)%201">Link to this property</a>

const CustomHostnameNewResponseStatusActiveRedeploying CustomHostnameNewResponseStatus = "active\_redeploying"

<a href="#(resource)%20custom_hostnames%20%3E%20(model)%20CustomHostnameNewResponse%20%3E%20(schema)%20%3E%20(property)%20status%20%3E%20(member)%202">Link to this property</a>

const CustomHostnameNewResponseStatusMoved CustomHostnameNewResponseStatus = "moved"

<a href="#(resource)%20custom_hostnames%20%3E%20(model)%20CustomHostnameNewResponse%20%3E%20(schema)%20%3E%20(property)%20status%20%3E%20(member)%203">Link to this property</a>

const CustomHostnameNewResponseStatusPendingDeletion CustomHostnameNewResponseStatus = "pending\_deletion"

<a href="#(resource)%20custom_hostnames%20%3E%20(model)%20CustomHostnameNewResponse%20%3E%20(schema)%20%3E%20(property)%20status%20%3E%20(member)%204">Link to this property</a>

const CustomHostnameNewResponseStatusDeleted CustomHostnameNewResponseStatus = "deleted"

<a href="#(resource)%20custom_hostnames%20%3E%20(model)%20CustomHostnameNewResponse%20%3E%20(schema)%20%3E%20(property)%20status%20%3E%20(member)%205">Link to this property</a>

const CustomHostnameNewResponseStatusPendingBlocked CustomHostnameNewResponseStatus = "pending\_blocked"

<a href="#(resource)%20custom_hostnames%20%3E%20(model)%20CustomHostnameNewResponse%20%3E%20(schema)%20%3E%20(property)%20status%20%3E%20(member)%206">Link to this property</a>

const CustomHostnameNewResponseStatusPendingMigration CustomHostnameNewResponseStatus = "pending\_migration"

<a href="#(resource)%20custom_hostnames%20%3E%20(model)%20CustomHostnameNewResponse%20%3E%20(schema)%20%3E%20(property)%20status%20%3E%20(member)%207">Link to this property</a>

const CustomHostnameNewResponseStatusPendingProvisioned CustomHostnameNewResponseStatus = "pending\_provisioned"

<a href="#(resource)%20custom_hostnames%20%3E%20(model)%20CustomHostnameNewResponse%20%3E%20(schema)%20%3E%20(property)%20status%20%3E%20(member)%208">Link to this property</a>

const CustomHostnameNewResponseStatusTestPending CustomHostnameNewResponseStatus = "test\_pending"

<a href="#(resource)%20custom_hostnames%20%3E%20(model)%20CustomHostnameNewResponse%20%3E%20(schema)%20%3E%20(property)%20status%20%3E%20(member)%209">Link to this property</a>

const CustomHostnameNewResponseStatusTestActive CustomHostnameNewResponseStatus = "test\_active"

<a href="#(resource)%20custom_hostnames%20%3E%20(model)%20CustomHostnameNewResponse%20%3E%20(schema)%20%3E%20(property)%20status%20%3E%20(member)%2010">Link to this property</a>

const CustomHostnameNewResponseStatusTestActiveApex CustomHostnameNewResponseStatus = "test\_active\_apex"

<a href="#(resource)%20custom_hostnames%20%3E%20(model)%20CustomHostnameNewResponse%20%3E%20(schema)%20%3E%20(property)%20status%20%3E%20(member)%2011">Link to this property</a>

const CustomHostnameNewResponseStatusTestBlocked CustomHostnameNewResponseStatus = "test\_blocked"

<a href="#(resource)%20custom_hostnames%20%3E%20(model)%20CustomHostnameNewResponse%20%3E%20(schema)%20%3E%20(property)%20status%20%3E%20(member)%2012">Link to this property</a>

const CustomHostnameNewResponseStatusTestFailed CustomHostnameNewResponseStatus = "test\_failed"

<a href="#(resource)%20custom_hostnames%20%3E%20(model)%20CustomHostnameNewResponse%20%3E%20(schema)%20%3E%20(property)%20status%20%3E%20(member)%2013">Link to this property</a>

const CustomHostnameNewResponseStatusProvisioned CustomHostnameNewResponseStatus = "provisioned"

<a href="#(resource)%20custom_hostnames%20%3E%20(model)%20CustomHostnameNewResponse%20%3E%20(schema)%20%3E%20(property)%20status%20%3E%20(member)%2014">Link to this property</a>

const CustomHostnameNewResponseStatusBlocked CustomHostnameNewResponseStatus = "blocked"

<a href="#(resource)%20custom_hostnames%20%3E%20(model)%20CustomHostnameNewResponse%20%3E%20(schema)%20%3E%20(property)%20status%20%3E%20(member)%2015">Link to this property</a>

</details>

<a href="#(resource)%20custom_hostnames%20%3E%20(model)%20CustomHostnameNewResponse%20%3E%20(schema)%20%3E%20(property)%20status">Link to this property</a>

VerificationErrors \[]stringOptional

These are errors that were encountered while trying to activate a hostname.

<a href="#(resource)%20custom_hostnames%20%3E%20(model)%20CustomHostnameNewResponse%20%3E%20(schema)%20%3E%20(property)%20verification_errors">Link to this property</a>

</details>

[Link to this property](<#(resource)%20custom_hostnames%20%3E%20(model)%20CustomHostnameNewResponse%20%3E%20(schema)>)

### Create Custom Hostname

Go

HTTPTypeScriptPythonGoTerraform

```
package main

import (
  "context"
  "fmt"

  "github.com/cloudflare/cloudflare-go"
  "github.com/cloudflare/cloudflare-go/custom_hostnames"
  "github.com/cloudflare/cloudflare-go/option"
)

func main() {
  client := cloudflare.NewClient(
    option.WithAPIToken("Sn3lZJTBX6kkg7OdcBUAxOO963GEIyGQqnFTOFYY"),
  )
  customHostname, err := client.CustomHostnames.New(context.TODO(), custom_hostnames.CustomHostnameNewParams{
    ZoneID: cloudflare.F("023e105f4ecef8ad9ca31a8372d0c353"),
    Hostname: cloudflare.F("app.example.com"),
  })
  if err != nil {
    panic(err.Error())
  }
  fmt.Printf("%+v\n", customHostname.ID)
}
```

200 example

```
{
  "errors": [
    {
      "code": 1000,
      "message": "message",
      "documentation_url": "documentation_url",
      "source": {
        "pointer": "pointer"
      }
    }
  ],
  "messages": [
    "string"
  ],
  "success": true,
  "result": {
    "id": "0d89c70d-ad9f-4843-b99f-6cc0252067e9",
    "hostname": "app.example.com",
    "created_at": "2020-02-06T18:11:23.531995Z",
    "custom_metadata": {
      "foo": "string"
    },
    "custom_origin_server": "origin2.example.com",
    "custom_origin_sni": "sni.example.com",
    "ownership_verification": {
      "name": "_cf-custom-hostname.app.example.com",
      "type": "txt",
      "value": "5cc07c04-ea62-4a5a-95f0-419334a875a4"
    },
    "ownership_verification_http": {
      "http_body": "5cc07c04-ea62-4a5a-95f0-419334a875a4",
      "http_url": "http://custom.test.com/.well-known/cf-custom-hostname-challenge/0d89c70d-ad9f-4843-b99f-6cc0252067e9"
    },
    "ssl": {
      "id": "0d89c70d-ad9f-4843-b99f-6cc0252067e9",
      "bundle_method": "ubiquitous",
      "certificate_authority": "google",
      "custom_certificate": "-----BEGIN CERTIFICATE-----\nMIIFJDCCBAygAwIBAgIQD0ifmj/Yi5NP/2gdUySbfzANBgkqhkiG9w0BAQsFADBN\nMQswCQYDVQQGEwJVUzEVMBMGA1UEChMMRGlnaUNlcnQgSW5jMScwJQYDVQQDEx5E...SzSHfXp5lnu/3V08I72q1QNzOCgY1XeL4GKVcj4or6cT6tX6oJH7ePPmfrBfqI/O\nOeH8gMJ+FuwtXYEPa4hBf38M5eU5xWG7\n-----END CERTIFICATE-----\n",
      "custom_csr_id": "7b163417-1d2b-4c84-a38a-2fb7a0cd7752",
      "custom_key": "-----BEGIN RSA PRIVATE KEY-----\nMIIEowIBAAKCAQEAwQHoetcl9+5ikGzV6cMzWtWPJHqXT3wpbEkRU9Yz7lgvddmG\ndtcGbg/1CGZu0jJGkMoppoUo4c3dts3iwqRYmBikUP77wwY2QGmDZw2FvkJCJlKn\nabIRuGvBKwzESIXgKk2016aTP6/dAjEHyo6SeoK8lkIySUvK0fyOVlsiEsCmOpid\ntnKX/a+50GjB79CJH4ER2lLVZnhePFR/zUOyPxZQQ4naHf7yu/b5jhO0f8fwt+py\nFxIXjbEIdZliWRkRMtzrHOJIhrmJ2A1J7iOrirbbwillwjjNVUWPf3IJ3M12S9pE\newooaeO2izNTERcG9HzAacbVRn2Y2SWIyT/18QIDAQABAoIBACbhTYXBZYKmYPCb\nHBR1IBlCQA2nLGf0qRuJNJZg5iEzXows/6tc8YymZkQE7nolapWsQ+upk2y5Xdp/\naxiuprIs9JzkYK8Ox0r+dlwCG1kSW+UAbX0bQ/qUqlsTvU6muVuMP8vZYHxJ3wmb\n+ufRBKztPTQ/rYWaYQcgC0RWI20HTFBMxlTAyNxYNWzX7RKFkGVVyB9RsAtmcc8g\n+j4OdosbfNoJPS0HeIfNpAznDfHKdxDk2Yc1tV6RHBrC1ynyLE9+TaflIAdo2MVv\nKLMLq51GqYKtgJFIlBRPQqKoyXdz3fGvXrTkf/WY9QNq0J1Vk5ERePZ54mN8iZB7\n9lwy/AkCgYEA6FXzosxswaJ2wQLeoYc7ceaweX/SwTvxHgXzRyJIIT0eJWgx13Wo\n/WA3Iziimsjf6qE+SI/8laxPp2A86VMaIt3Z3mJN/CqSVGw8LK2AQst+OwdPyDMu\niacE8lj/IFGC8mwNUAb9CzGU3JpU4PxxGFjS/eMtGeRXCWkK4NE+G08CgYEA1Kp9\nN2JrVlqUz+gAX+LPmE9OEMAS9WQSQsfCHGogIFDGGcNf7+uwBM7GAaSJIP01zcoe\nVAgWdzXCv3FLhsaZoJ6RyLOLay5phbu1iaTr4UNYm5WtYTzMzqh8l1+MFFDl9xDB\nvULuCIIrglM5MeS/qnSg1uMoH2oVPj9TVst/ir8CgYEAxrI7Ws9Zc4Bt70N1As+U\nlySjaEVZCMkqvHJ6TCuVZFfQoE0r0whdLdRLU2PsLFP+q7qaeZQqgBaNSKeVcDYR\n9B+nY/jOmQoPewPVsp/vQTCnE/R81spu0mp0YI6cIheT1Z9zAy322svcc43JaWB7\nmEbeqyLOP4Z4qSOcmghZBSECgYACvR9Xs0DGn+wCsW4vze/2ei77MD4OQvepPIFX\ndFZtlBy5ADcgE9z0cuVB6CiL8DbdK5kwY9pGNr8HUCI03iHkW6Zs+0L0YmihfEVe\nPG19PSzK9CaDdhD9KFZSbLyVFmWfxOt50H7YRTTiPMgjyFpfi5j2q348yVT0tEQS\nfhRqaQKBgAcWPokmJ7EbYQGeMbS7HC8eWO/RyamlnSffdCdSc7ue3zdVJxpAkQ8W\nqu80pEIF6raIQfAf8MXiiZ7auFOSnHQTXUbhCpvDLKi0Mwq3G8Pl07l+2s6dQG6T\nlv6XTQaMyf6n1yjzL+fzDrH3qXMxHMO/b13EePXpDMpY7HQpoLDi\n-----END RSA PRIVATE KEY-----\n",
      "dcv_delegation_records": [
        {
          "cname": "_acme-challenge.example.com",
          "cname_target": "dcv.cloudflare.com",
          "emails": [
            "administrator@example.com",
            "webmaster@example.com"
          ],
          "http_body": "ca3-574923932a82475cb8592200f1a2a23d",
          "http_url": "http://app.example.com/.well-known/pki-validation/ca3-da12a1c25e7b48cf80408c6c1763b8a2.txt",
          "status": "pending",
          "txt_name": "_acme-challenge.app.example.com",
          "txt_value": "810b7d5f01154524b961ba0cd578acc2"
        }
      ],
      "expires_on": "2021-02-06T18:11:23.531995Z",
      "hosts": [
        "app.example.com",
        "*.app.example.com"
      ],
      "issuer": "DigiCertInc",
      "method": "http",
      "serial_number": "6743787633689793699141714808227354901",
      "settings": {
        "ciphers": [
          "ECDHE-RSA-AES128-GCM-SHA256",
          "AES128-SHA"
        ],
        "early_hints": "on",
        "http2": "on",
        "min_tls_version": "1.2",
        "tls_1_3": "on"
      },
      "signature": "SHA256WithRSA",
      "status": "pending_validation",
      "type": "dv",
      "uploaded_on": "2020-02-06T18:11:23.531995Z",
      "validation_errors": [
        {
          "message": "SERVFAIL looking up CAA for app.example.com"
        }
      ],
      "validation_records": [
        {
          "cname": "_acme-challenge.example.com",
          "cname_target": "dcv.cloudflare.com",
          "emails": [
            "administrator@example.com",
            "webmaster@example.com"
          ],
          "http_body": "ca3-574923932a82475cb8592200f1a2a23d",
          "http_url": "http://app.example.com/.well-known/pki-validation/ca3-da12a1c25e7b48cf80408c6c1763b8a2.txt",
          "status": "pending",
          "txt_name": "_acme-challenge.app.example.com",
          "txt_value": "810b7d5f01154524b961ba0cd578acc2"
        }
      ],
      "wildcard": false
    },
    "status": "pending",
    "verification_errors": [
      "None of the A or AAAA records are owned by this account and the pre-generated ownership verification token was not found."
    ]
  }
}
```

##### Returns Examples

200 example

```
{
  "errors": [
    {
      "code": 1000,
      "message": "message",
      "documentation_url": "documentation_url",
      "source": {
        "pointer": "pointer"
      }
    }
  ],
  "messages": [
    "string"
  ],
  "success": true,
  "result": {
    "id": "0d89c70d-ad9f-4843-b99f-6cc0252067e9",
    "hostname": "app.example.com",
    "created_at": "2020-02-06T18:11:23.531995Z",
    "custom_metadata": {
      "foo": "string"
    },
    "custom_origin_server": "origin2.example.com",
    "custom_origin_sni": "sni.example.com",
    "ownership_verification": {
      "name": "_cf-custom-hostname.app.example.com",
      "type": "txt",
      "value": "5cc07c04-ea62-4a5a-95f0-419334a875a4"
    },
    "ownership_verification_http": {
      "http_body": "5cc07c04-ea62-4a5a-95f0-419334a875a4",
      "http_url": "http://custom.test.com/.well-known/cf-custom-hostname-challenge/0d89c70d-ad9f-4843-b99f-6cc0252067e9"
    },
    "ssl": {
      "id": "0d89c70d-ad9f-4843-b99f-6cc0252067e9",
      "bundle_method": "ubiquitous",
      "certificate_authority": "google",
      "custom_certificate": "-----BEGIN CERTIFICATE-----\nMIIFJDCCBAygAwIBAgIQD0ifmj/Yi5NP/2gdUySbfzANBgkqhkiG9w0BAQsFADBN\nMQswCQYDVQQGEwJVUzEVMBMGA1UEChMMRGlnaUNlcnQgSW5jMScwJQYDVQQDEx5E...SzSHfXp5lnu/3V08I72q1QNzOCgY1XeL4GKVcj4or6cT6tX6oJH7ePPmfrBfqI/O\nOeH8gMJ+FuwtXYEPa4hBf38M5eU5xWG7\n-----END CERTIFICATE-----\n",
      "custom_csr_id": "7b163417-1d2b-4c84-a38a-2fb7a0cd7752",
      "custom_key": "-----BEGIN RSA PRIVATE KEY-----\nMIIEowIBAAKCAQEAwQHoetcl9+5ikGzV6cMzWtWPJHqXT3wpbEkRU9Yz7lgvddmG\ndtcGbg/1CGZu0jJGkMoppoUo4c3dts3iwqRYmBikUP77wwY2QGmDZw2FvkJCJlKn\nabIRuGvBKwzESIXgKk2016aTP6/dAjEHyo6SeoK8lkIySUvK0fyOVlsiEsCmOpid\ntnKX/a+50GjB79CJH4ER2lLVZnhePFR/zUOyPxZQQ4naHf7yu/b5jhO0f8fwt+py\nFxIXjbEIdZliWRkRMtzrHOJIhrmJ2A1J7iOrirbbwillwjjNVUWPf3IJ3M12S9pE\newooaeO2izNTERcG9HzAacbVRn2Y2SWIyT/18QIDAQABAoIBACbhTYXBZYKmYPCb\nHBR1IBlCQA2nLGf0qRuJNJZg5iEzXows/6tc8YymZkQE7nolapWsQ+upk2y5Xdp/\naxiuprIs9JzkYK8Ox0r+dlwCG1kSW+UAbX0bQ/qUqlsTvU6muVuMP8vZYHxJ3wmb\n+ufRBKztPTQ/rYWaYQcgC0RWI20HTFBMxlTAyNxYNWzX7RKFkGVVyB9RsAtmcc8g\n+j4OdosbfNoJPS0HeIfNpAznDfHKdxDk2Yc1tV6RHBrC1ynyLE9+TaflIAdo2MVv\nKLMLq51GqYKtgJFIlBRPQqKoyXdz3fGvXrTkf/WY9QNq0J1Vk5ERePZ54mN8iZB7\n9lwy/AkCgYEA6FXzosxswaJ2wQLeoYc7ceaweX/SwTvxHgXzRyJIIT0eJWgx13Wo\n/WA3Iziimsjf6qE+SI/8laxPp2A86VMaIt3Z3mJN/CqSVGw8LK2AQst+OwdPyDMu\niacE8lj/IFGC8mwNUAb9CzGU3JpU4PxxGFjS/eMtGeRXCWkK4NE+G08CgYEA1Kp9\nN2JrVlqUz+gAX+LPmE9OEMAS9WQSQsfCHGogIFDGGcNf7+uwBM7GAaSJIP01zcoe\nVAgWdzXCv3FLhsaZoJ6RyLOLay5phbu1iaTr4UNYm5WtYTzMzqh8l1+MFFDl9xDB\nvULuCIIrglM5MeS/qnSg1uMoH2oVPj9TVst/ir8CgYEAxrI7Ws9Zc4Bt70N1As+U\nlySjaEVZCMkqvHJ6TCuVZFfQoE0r0whdLdRLU2PsLFP+q7qaeZQqgBaNSKeVcDYR\n9B+nY/jOmQoPewPVsp/vQTCnE/R81spu0mp0YI6cIheT1Z9zAy322svcc43JaWB7\nmEbeqyLOP4Z4qSOcmghZBSECgYACvR9Xs0DGn+wCsW4vze/2ei77MD4OQvepPIFX\ndFZtlBy5ADcgE9z0cuVB6CiL8DbdK5kwY9pGNr8HUCI03iHkW6Zs+0L0YmihfEVe\nPG19PSzK9CaDdhD9KFZSbLyVFmWfxOt50H7YRTTiPMgjyFpfi5j2q348yVT0tEQS\nfhRqaQKBgAcWPokmJ7EbYQGeMbS7HC8eWO/RyamlnSffdCdSc7ue3zdVJxpAkQ8W\nqu80pEIF6raIQfAf8MXiiZ7auFOSnHQTXUbhCpvDLKi0Mwq3G8Pl07l+2s6dQG6T\nlv6XTQaMyf6n1yjzL+fzDrH3qXMxHMO/b13EePXpDMpY7HQpoLDi\n-----END RSA PRIVATE KEY-----\n",
      "dcv_delegation_records": [
        {
          "cname": "_acme-challenge.example.com",
          "cname_target": "dcv.cloudflare.com",
          "emails": [
            "administrator@example.com",
            "webmaster@example.com"
          ],
          "http_body": "ca3-574923932a82475cb8592200f1a2a23d",
          "http_url": "http://app.example.com/.well-known/pki-validation/ca3-da12a1c25e7b48cf80408c6c1763b8a2.txt",
          "status": "pending",
          "txt_name": "_acme-challenge.app.example.com",
          "txt_value": "810b7d5f01154524b961ba0cd578acc2"
        }
      ],
      "expires_on": "2021-02-06T18:11:23.531995Z",
      "hosts": [
        "app.example.com",
        "*.app.example.com"
      ],
      "issuer": "DigiCertInc",
      "method": "http",
      "serial_number": "6743787633689793699141714808227354901",
      "settings": {
        "ciphers": [
          "ECDHE-RSA-AES128-GCM-SHA256",
          "AES128-SHA"
        ],
        "early_hints": "on",
        "http2": "on",
        "min_tls_version": "1.2",
        "tls_1_3": "on"
      },
      "signature": "SHA256WithRSA",
      "status": "pending_validation",
      "type": "dv",
      "uploaded_on": "2020-02-06T18:11:23.531995Z",
      "validation_errors": [
        {
          "message": "SERVFAIL looking up CAA for app.example.com"
        }
      ],
      "validation_records": [
        {
          "cname": "_acme-challenge.example.com",
          "cname_target": "dcv.cloudflare.com",
          "emails": [
            "administrator@example.com",
            "webmaster@example.com"
          ],
          "http_body": "ca3-574923932a82475cb8592200f1a2a23d",
          "http_url": "http://app.example.com/.well-known/pki-validation/ca3-da12a1c25e7b48cf80408c6c1763b8a2.txt",
          "status": "pending",
          "txt_name": "_acme-challenge.app.example.com",
          "txt_value": "810b7d5f01154524b961ba0cd578acc2"
        }
      ],
      "wildcard": false
    },
    "status": "pending",
    "verification_errors": [
      "None of the A or AAAA records are owned by this account and the pre-generated ownership verification token was not found."
    ]
  }
}
```